                PROGRAM
                MAP
                  MODULE('api')
                    GetSysColor(signed nIndex),long,pascal,NAME('GetSysColor')
                  END
                END

Window WINDOW('Caption'),AT(,,471,127),FONT('Tahoma',8,,FONT:regular,CHARSET:CYRILLIC),CENTER,ICON('bclients.ico'), |
         SYSTEM,GRAY,MAX,DOUBLE
       BUTTON('   '),AT(18,17,139,42),USE(?Button1),ICON('bbackenter.ico')
       BUTTON(' '),AT(166,17,139,42),USE(?Button3),ICON('bbackfiz.ico')
       BUTTON('   ...'),AT(314,17,139,42),USE(?Button5),ICON('bcenn.ico')
       BUTTON(' '),AT(18,68,139,42),USE(?Button2),ICON('bclients.ico')
       BUTTON(' <255>'),AT(166,68,139,42),USE(?Button4),ICON('bdelivery.ico')
       BUTTON,AT(424,82,29,28),USE(?Button6),TIP(' ')
       BUTTON,AT(386,82,29,28),USE(?Button7),TIP('  ')
     END

DefaultWindowColor      EQUATE(COLOR:BtnFace)
MaxState                EQUATE(60)
ClickState              EQUATE(80)
AnimationStep           EQUATE(5)
TimerStep               EQUATE(3)
FrameSize               EQUATE(3)
IconSize                EQUATE(22)

TBControlsQueue         QUEUE,TYPE
ButtonFeq                 LONG
RegionFeq                 LONG
ImageFeq                  LONG
TextFeq                   LONG
PanelFeq                  LONG
FrameFeq                  LONG
Color                     LONG
                        END

TBAnimationQueue        QUEUE,TYPE
RegionFeq                 LONG
State1                    BYTE
State2                    BYTE
                        END

TBMetroColors           QUEUE,TYPE
Color                     LONG
                        END

TileButtonClass         CLASS
w                         &Window,PRIVATE
Controls                  &TBControlsQueue,PRIVATE
Animation                 &TBAnimationQueue,PRIVATE
MetroColors               &TBMetroColors,PRIVATE
FontName                  STRING(255),PRIVATE
FontSize                  LONG,PRIVATE
FontColor                 LONG,PRIVATE
FontStyle                 LONG,PRIVATE
FontCharset               LONG,PRIVATE
INIFile                   STRING(255),PRIVATE

Construct                 PROCEDURE
Destruct                  PROCEDURE
Init                      PROCEDURE(Window w, STRING INIFile, STRING FontName, LONG FontSize, LONG FontColor, LONG FontStyle, LONG FontCharset)
Kill                      PROCEDURE
Add                       PROCEDURE(LONG Feq, <LONG Color>)
Resize                    PROCEDURE(LONG Feq),PRIVATE
ResizeAll                 PROCEDURE()
SamePos                   PROCEDURE(LONG Feq1, LONG Feq2),PRIVATE
TakeEvent                 PROCEDURE
AnimationProcess          PROCEDURE
AddFade                   PROCEDURE(LONG Feq, BYTE State1, BYTE State2)
MixColors                 PROCEDURE(LONG pColor1, LONG pColor2, BYTE pPercentageMix), LONG,PRIVATE
GetColorFromRGB           PROCEDURE(BYTE R, BYTE G, BYTE B),LONG
AddColor                  PROCEDURE(LONG Color)
RemoveColor               PROCEDURE(LONG Color)
GetRandomColor            PROCEDURE(<LONG Current>),LONG
                        END

TileButton      TileButtonClass

  CODE
  OPEN(Window)
  TileButton.Init(Window,'tilesbtn.ini','Tahoma', 10, COLOR:White,  FONT:Bold, CHARSET:CYRILLIC)
  TileButton.Add(?button1,TileButton.GetColorFromRGB(243,178,0))
  TileButton.Add(?button2,TileButton.GetRandomColor())
  TileButton.Add(?button3,TileButton.GetRandomColor())
  TileButton.Add(?button4,TileButton.GetRandomColor())
  TileButton.Add(?button5,TileButton.GetRandomColor())
  TileButton.Add(?button6,TileButton.GetRandomColor())
  TileButton.Add(?button7,COLOR:Gray)
  TileButton.ResizeAll
  ACCEPT
    TileButton.TakeEvent
    CASE ACCEPTED()
    OF ?Button1
      MESSAGE('Button 1')
    OF ?Button2
      MESSAGE('Button 2')
    OF ?Button3
      MESSAGE('Button 3')
    OF ?Button4
      MESSAGE('Button 4')
    OF ?Button5
      !MESSAGE('Button 5')
    OF ?Button6
      Window{PROP:Color} = TileButton.GetRandomColor(Window{PROP:Color})
    OF ?Button7
      Window{PROP:Color} = DefaultWindowColor
    END
    CASE EVENT()
    OF EVENT:DoResize
      TileButton.ResizeAll
    END
  END
  CLOSE(Window)


TileButtonClass.Construct PROCEDURE
  CODE
  SELF.Controls &= NEW(TBControlsQueue)
  SELF.Animation &= NEW(TBAnimationQueue)
  SELF.MetroColors &= NEW(TBMetroColors)

  SELF.AddColor(SELF.GetColorFromRGB(243,178,0))
  SELF.AddColor(SELF.GetColorFromRGB(99,47,0))
  SELF.AddColor(SELF.GetColorFromRGB(70,23,180))
  SELF.AddColor(SELF.GetColorFromRGB(0,193,63))
  SELF.AddColor(SELF.GetColorFromRGB(170,64,255))
  SELF.AddColor(SELF.GetColorFromRGB(145,209,0))
  SELF.AddColor(SELF.GetColorFromRGB(254,124,34))
  SELF.AddColor(SELF.GetColorFromRGB(119,185,0))
  SELF.AddColor(SELF.GetColorFromRGB(176,30,0))
  SELF.AddColor(SELF.GetColorFromRGB(0,106,193))
  SELF.AddColor(SELF.GetColorFromRGB(255,152,29))
  SELF.AddColor(SELF.GetColorFromRGB(31,174,255))
  SELF.AddColor(SELF.GetColorFromRGB(255,183,0))
  SELF.AddColor(SELF.GetColorFromRGB(37,114,235))
  SELF.AddColor(SELF.GetColorFromRGB(193,0,79))
  SELF.AddColor(SELF.GetColorFromRGB(0,130,135))
  SELF.AddColor(SELF.GetColorFromRGB(255,46,18))
  SELF.AddColor(SELF.GetColorFromRGB(86,197,255))
  SELF.AddColor(SELF.GetColorFromRGB(255,118,188))
  SELF.AddColor(SELF.GetColorFromRGB(173,16,60))
  SELF.AddColor(SELF.GetColorFromRGB(114,0,172))
  SELF.AddColor(SELF.GetColorFromRGB(25,153,0))
  SELF.AddColor(SELF.GetColorFromRGB(255,29,119))
  SELF.AddColor(SELF.GetColorFromRGB(0,216,204))
  SELF.AddColor(SELF.GetColorFromRGB(0,163,163))
  !SELF.AddColor(SELF.GetColorFromRGB(0,0,0))
  !SELF.AddColor(SELF.GetColorFromRGB(255,255,255))

TileButtonClass.Destruct PROCEDURE
  CODE
  FREE(SELF.Controls)
  FREE(SELF.Animation)
  FREE(SELF.MetroColors)
  IF ~SELF.Controls &= NULL
    DISPOSE(SELF.Controls)
  END
  IF ~SELF.Animation &= NULL
    DISPOSE(SELF.Animation)
  END
  IF ~SELF.MetroColors &= NULL
    DISPOSE(SELF.MetroColors)
  END

TileButtonClass.Init    PROCEDURE(Window w, STRING INIFile, STRING FontName, LONG FontSize, LONG FontColor, LONG FontStyle, LONG FontCharset)
LOC:Color               LONG
  CODE
  SELF.w &= w
  SELF.w{PROP:Buffer} = TRUE
  SELF.w{PROP:Timer} = TimerStep
  SELF.INIFile = INIFile
  LOC:Color = GETINI('MainWindow','Color', DefaultWindowColor, SELF.INIFile)
  SELF.w{PROP:Color} = LOC:Color
  SELF.FontName = FontName
  SELF.FontSize = FontSize
  SELF.FontColor = FontColor
  SELF.FontStyle = FontStyle
  SELF.FontCharset = FontCharset

TileButtonClass.Kill    PROCEDURE
  CODE
  PUTINI('MainWindow','Color', SELF.w{PROP:Color}, SELF.INIFile)

TileButtonClass.Add     PROCEDURE(LONG Feq, <LONG Color>)
  CODE
  CLEAR(SELF.Controls)
  SELF.Controls.ButtonFeq = Feq
  SELF.Controls.ButtonFeq{PROP:Hide} = TRUE

  IF OMITTED(3)
    SELF.Controls.Color = SELF.Controls.ButtonFeq{PROP:Color, 1}
  ELSE
    SELF.Controls.Color = Color
  END
  SELF.RemoveColor(SELF.Controls.Color)

  ! frame panel
  SELF.Controls.FrameFeq = CREATE(0, CREATE:Panel, SELF.Controls.ButtonFeq{PROP:Parent})
  SELF.Controls.FrameFeq{PROP:Fill} = SELF.w{PROP:Color}
  SELF.Controls.FrameFeq{PROP:Bevel, 2} = -1
  SELF.Controls.FrameFeq{PROP:Hide} = TRUE

  ! panel
  SELF.Controls.PanelFeq = CREATE(0, CREATE:Panel, SELF.Controls.ButtonFeq{PROP:Parent})
  SELF.Controls.PanelFeq{PROP:Fill} = SELF.Controls.Color
  SELF.Controls.PanelFeq{PROP:Bevel, 2} = -1
  SELF.Controls.PanelFeq{PROP:Hide} = FALSE

  ! image
  SELF.Controls.ImageFeq = CREATE(0, CREATE:Image, SELF.Controls.ButtonFeq{PROP:Parent})
  SELF.Controls.ImageFeq{PROP:Text} = SELF.Controls.ButtonFeq{PROP:Icon}
  SELF.Controls.ImageFeq{PROP:Width} = IconSize
  SELF.Controls.ImageFeq{PROP:Height} = IconSize
  IF CLIP(SELF.Controls.ButtonFeq{PROP:Icon}) <> ''
  SELF.Controls.ImageFeq{PROP:Hide} = FALSE
  END

  ! text
  SELF.Controls.TextFeq = CREATE(0, CREATE:Prompt, SELF.Controls.ButtonFeq{PROP:Parent})
  SELF.Controls.TextFeq{PROP:Trn} = TRUE
  SELF.Controls.TextFeq{PROP:Text} = SELF.Controls.ButtonFeq{PROP:Text}
  SETFONT(SELF.Controls.TextFeq, SELF.FontName, SELF.FontSize, SELF.FontColor, SELF.FontStyle, SELF.FontCharset)
  SELF.Controls.TextFeq{PROP:Hide} = FALSE

  ! region
  SELF.Controls.RegionFeq = CREATE(0, CREATE:Region, SELF.Controls.ButtonFeq{PROP:Parent})
  SELF.Controls.RegionFeq{PROP:Cursor} = '~hand.cur'
  SELF.Controls.RegionFeq{PROP:Imm} = TRUE
  SELF.Controls.RegionFeq{PROP:Tip} = SELF.Controls.ButtonFeq{PROP:Tip}
  SELF.Controls.RegionFeq{PROP:Hide} = FALSE

  ADD(SELF.Controls)
  SELF.Resize(SELF.Controls.ButtonFeq)

TileButtonClass.Resize  PROCEDURE(LONG Feq)!,PRIVATE
  CODE
  SELF.Controls.ButtonFeq = Feq
  GET(SELF.Controls, SELF.Controls.ButtonFeq)

  SELF.SamePos(SELF.Controls.ButtonFeq, SELF.Controls.FrameFeq) ! frame panel
  SELF.Controls.FrameFeq{PROP:XPos} = SELF.Controls.FrameFeq{PROP:XPos} - FrameSize
  SELF.Controls.FrameFeq{PROP:YPos} = SELF.Controls.FrameFeq{PROP:YPos} - FrameSize
  SELF.Controls.FrameFeq{PROP:Width} = SELF.Controls.FrameFeq{PROP:Width} + FrameSize * 2
  SELF.Controls.FrameFeq{PROP:Height} = SELF.Controls.FrameFeq{PROP:Height} + FrameSize * 2

  SELF.SamePos(SELF.Controls.ButtonFeq, SELF.Controls.PanelFeq) ! panel

  SELF.SamePos(SELF.Controls.ButtonFeq, SELF.Controls.ImageFeq) ! image
  SELF.Controls.ImageFeq{PROP:XPos} = SELF.Controls.ImageFeq{PROP:XPos} + 6
  SELF.Controls.ImageFeq{PROP:YPos} = SELF.Controls.ImageFeq{PROP:YPos} + 4

  SELF.SamePos(SELF.Controls.ButtonFeq, SELF.Controls.TextFeq) ! text
  SELF.Controls.TextFeq{PROP:XPos} = SELF.Controls.TextFeq{PROP:XPos} + 4
  SELF.Controls.TextFeq{PROP:YPos} = SELF.Controls.ButtonFeq{PROP:Ypos} + SELF.Controls.ButtonFeq{PROP:Height} - (SELF.FontSize + SELF.FontSize / 4)

  SELF.SamePos(SELF.Controls.ButtonFeq, SELF.Controls.RegionFeq)   ! region

TileButtonClass.ResizeAll PROCEDURE()
  CODE
  LOOP W# = 1 TO RECORDS(SELF.Controls)
    GET(SELF.Controls, W#)
    SELF.Resize(SELF.Controls.ButtonFeq)
  END

TileButtonClass.SamePos PROCEDURE(LONG FEQ1, LONG FEQ2)!,PRIVATE
X                       LONG
Y                       LONG
W                       LONG
H                       LONG
  CODE
  GETPOSITION(FEQ1, X, Y, W, H)
  SETPOSITION(FEQ2, X, Y, W, H)

TileButtonClass.TakeEvent PROCEDURE
  CODE
  CASE EVENT()
  OF EVENT:Timer
    SELF.AnimationProcess
  END
  IF FIELD()
    SELF.Controls.RegionFeq = FIELD()
    GET(SELF.Controls, SELF.Controls.RegionFeq)
    IF ERRORCODE() = FALSE
      CASE EVENT()
      OF EVENT:MouseDown
        SELF.Controls.PanelFeq{PROP:Fill} = SELF.MixColors(COLOR:White, SELF.Controls.Color, ClickState)
        SELF.Controls.ImageFeq{PROP:XPos} = SELF.Controls.ImageFeq{PROP:XPos} + 1
        SELF.Controls.ImageFeq{PROP:YPos} = SELF.Controls.ImageFeq{PROP:YPos} + 1
        SELF.Controls.TextFeq{PROP:XPos} = SELF.Controls.TextFeq{PROP:XPos} + 1
        SELF.Controls.TextFeq{PROP:YPos} = SELF.Controls.TextFeq{PROP:YPos} + 1
      OF EVENT:MouseUp
        SELF.Controls.PanelFeq{PROP:Fill} = SELF.Controls.Color
        POST(EVENT:Accepted, SELF.Controls.ButtonFeq)
        SELF.Controls.ImageFeq{PROP:XPos} = SELF.Controls.ImageFeq{PROP:XPos} - 1
        SELF.Controls.ImageFeq{PROP:YPos} = SELF.Controls.ImageFeq{PROP:YPos} - 1
        SELF.Controls.TextFeq{PROP:XPos} = SELF.Controls.TextFeq{PROP:XPos} - 1
        SELF.Controls.TextFeq{PROP:YPos} = SELF.Controls.TextFeq{PROP:YPos} - 1
      OF EVENT:MouseIn
        SELF.AddFade(SELF.Controls.RegionFeq, 0, MaxState)
        !SELF.Controls.FrameFeq{PROP:Fill} = SELF.MixColors(COLOR:White, SELF.Controls.Color, MaxState)
        !SELF.Controls.FrameFeq{PROP:Hide} = FALSE
      OF EVENT:MouseOut
        SELF.AddFade(SELF.Controls.RegionFeq, MaxState, 0)
        !SELF.Controls.FrameFeq{PROP:Hide} = TRUE
      END
    END
  END

TileButtonClass.AnimationProcess PROCEDURE
  CODE
  !TARGET{PROP:text} = RECORDS(SELF.Animation)
  LOOP W# = RECORDS(SELF.Animation) TO 1 BY -1
    GET(SELF.Animation, W#)
    SELF.Controls.RegionFeq = SELF.Animation.RegionFeq
    GET(SELF.Controls, SELF.Controls.RegionFeq)

    ! fade in
    IF SELF.Animation.State1 < SELF.Animation.State2
      IF SELF.Animation.State1 = 0
        SELF.Controls.FrameFeq{PROP:Hide} = FALSE
      END
      SELF.Animation.State1 += AnimationStep
      SELF.Controls.FrameFeq{PROP:Fill} = SELF.MixColors(SELF.w{PROP:Color}, SELF.Controls.Color, SELF.Animation.State1)
      IF SELF.Animation.State1 => SELF.Animation.State2
        DELETE(SELF.Animation)
      ELSE
        PUT(SELF.Animation)
      END
    ! fade out
    ELSIF SELF.Animation.State1 > SELF.Animation.State2
      SELF.Animation.State1 -= AnimationStep
      SELF.Controls.FrameFeq{PROP:Fill} = SELF.MixColors(SELF.w{PROP:Color}, SELF.Controls.Color, SELF.Animation.State1)
      IF SELF.Animation.State1 <= SELF.Animation.State2
        SELF.Controls.FrameFeq{PROP:Hide} = TRUE
        DELETE(SELF.Animation)
      ELSE
        PUT(SELF.Animation)
      END
    END

  END

TileButtonClass.AddFade     PROCEDURE(LONG Feq, BYTE State1, BYTE State2)
  CODE
  SELF.Animation.RegionFeq = Feq
  GET(SELF.Animation, SELF.Animation.RegionFeq)
  IF ERRORCODE()
    SELF.Animation.State1 = State1
    SELF.Animation.State2 = State2
    ADD(SELF.Animation)
  ELSE
    ! fade in exist and new entry fade out
    IF SELF.Animation.State1 < SELF.Animation.State2 AND State1 > State2
      State1 = SELF.Animation.State1
    ! fade out exist and new entry fade in
    ELSIF SELF.Animation.State1 > SELF.Animation.State2 AND State1 < State2
      State1 = SELF.Animation.State1
    END
    DELETE(SELF.Animation)
    SELF.Animation.State1 = State1
    SELF.Animation.State2 = State2
    ADD(SELF.Animation)
  END

TileButtonClass.MixColors   PROCEDURE(LONG pColor1, LONG pColor2, BYTE pPercentageMix)

CWColor1           LONG,AUTO
RGBT1              GROUP,OVER(CWColor1)
R                    BYTE
G                    BYTE
B                    BYTE
DitherMode           BYTE
                   END
CWColor2           LONG,AUTO
RGBT2              GROUP,OVER(CWColor2)
R                    BYTE
G                    BYTE
B                    BYTE
DitherMode           BYTE
                   END
RetCWColor         LONG
RetRGBT            GROUP,OVER(RetCWColor)
R                    BYTE
G                    BYTE
B                    BYTE
DitherMode           BYTE
                   END

DitherColors       LONG,AUTO

  CODE
  IF pPercentageMix > 100
     pPercentageMix = 100
  END

  DitherColors = SYSTEM {PROP:ColorHighByte} * 1000000h

  IF BAND (pColor1, 80000000h)
    pColor1 = GetSysColor (BAND (pColor1, 0FFFFh))
  ELSE
    pColor1 = BOR (DitherColors, BAND (pColor1, 0FFFFFFh))
  END
  IF BAND (pColor2, 80000000h)
    pColor2 = GetSysColor (BAND (pColor2, 0FFFFh))
  ELSE
    pColor2 = BOR (DitherColors, BAND (pColor2, 0FFFFFFh))
  END

  CWColor1 = pColor1
  CWColor2 = pColor2

  RetRGBT.R = (RGBT1.R + ((RGBT2.R - RGBT1.R) * pPercentageMix/100))
  RetRGBT.G = (RGBT1.G + ((RGBT2.G - RGBT1.G) * pPercentageMix/100))
  RetRGBT.B = (RGBT1.B + ((RGBT2.B - RGBT1.B) * pPercentageMix/100))
  RetRGBT.DitherMode = 0

  RETURN BOR (RetCWColor, DitherColors)

TileButtonClass.GetColorFromRGB           PROCEDURE(BYTE R, BYTE G, BYTE B)
CWColor1           LONG,AUTO
RGBT1              GROUP,OVER(CWColor1)
R                    BYTE
G                    BYTE
B                    BYTE
DitherMode           BYTE
                   END
  CODE
  RGBT1.R = R
  RGBT1.G = G
  RGBT1.B = B
  RGBT1.DitherMode = 0
  RETURN CWColor1
TileButtonClass.AddColor                  PROCEDURE(LONG Color)
  CODE
  SELF.MetroColors.Color = Color
  ADD(SELF.MetroColors)

TileButtonClass.RemoveColor               PROCEDURE(LONG Color)
  CODE
  SELF.MetroColors.Color = Color
  GET(SELF.MetroColors, SELF.MetroColors.Color)
  IF NOT ERRORCODE()
    DELETE(SELF.MetroColors)
  END

TileButtonClass.GetRandomColor            PROCEDURE(<LONG Current>)
  CODE
  Found# = FALSE
  LOOP E# = 1 TO RECORDS(SELF.MetroColors)
    GET(SELF.MetroColors,E#)
    IF SELF.MetroColors.Color = Current
      Found# = TRUE
      BREAK
    END
  END
  Num# = 1
  IF Found# = TRUE
    Num# = E# + 1
  END
  IF Num# > RECORDS(SELF.MetroColors)
    Num# = 1
  END
  GET(SELF.MetroColors, Num#)
  RETURN SELF.MetroColors.Color

